////////////////////////////////////////////////////////////////////////////
//  child.cpp
//
//  This file is part of the WinNT Pipes example demonstrating how to 
//  use anonymous pipes to communicate between a parent and child 
//  process through the child's STDIN/STDOUT. 
//
//  George Cross, Borland C++ Developer Support March 97
//
//  Built with Borland C++ 5.01
//
//  Build using,
// 
//    bcc32 thisfile.cpp
////////////////////////////////////////////////////////////////////////////

#define BUFSIZE  128
#define STRICT
#include <windows.h>
#include <string.h>
#include <stdio.h>

void main()
{
  unsigned long nbytes, nreads=0, ntotalbytes=0;
  char data[BUFSIZE];
  bool bSuccess;
  
  HANDLE hStdIn, hStdOut;
  hStdIn = GetStdHandle(STD_INPUT_HANDLE);
  hStdOut = GetStdHandle(STD_OUTPUT_HANDLE);
  


  //Beware that ReadFile does not append '\0' after reading.
  //One might want to do that oneself.

  //Also strlen doesn't include terminating null character, which 
  //sometimes one might want when calling WriteFile.

  memset(data,0,sizeof(data));
  sprintf(data,"CHILD PROCESS:  About to read from stdin...\r\n");
  WriteFile(hStdOut, data, strlen(data), &nbytes, NULL);
   
  do{
    memset(data,0,sizeof(data));
    bSuccess = ReadFile(hStdIn, data, sizeof(data)-1, &nbytes, NULL);
    nreads++;
    ntotalbytes += nbytes;
    WriteFile(hStdOut, data, strlen(data), &nbytes, NULL);
  }while(bSuccess && nbytes!=0 && strchr(data,0x1A)==NULL);
  sprintf(data, 
          "\r\nCHILD PROCESS: %d bytes read from STDIN. "
          "%d scans performed.\r\n", 
          ntotalbytes, nreads);
  WriteFile(hStdOut, data, strlen(data), &nbytes, NULL);

  CloseHandle(hStdIn);
  CloseHandle(hStdOut);
}
