////////////////////////////////////////////////////////////////////////////
//  parent.cpp
//
//  This file is part of the WinNT Pipes example demonstrating how to 
//  use anonymous pipes to communicate between a parent and child 
//  process using the child's STDIN/STDOUT. 
//
//  George Cross, Borland C++ Developer Support March 1997
//
//  Built with Borland C++ 5.01
////////////////////////////////////////////////////////////////////////////

#include <owl\pch.h>
#pragma hdrstop
#include <owl\controlb.h>
#include <owl\buttonga.h>

#include "decframe.h"

////////////////////////////////////////////////////////////////////////////
// TPipes32Application class for this application
////////////////////////////////////////////////////////////////////////////
class TPipes32Application : public TApplication {
public:
  TPipes32Application () : TApplication () {}
  void InitMainWindow ();
};                                               //End TNewApplication decl.

void TPipes32Application::InitMainWindow () {

  TPipes32Frame* frame =  new TPipes32Frame ();   //The main window object

  TControlBar* cb = new TControlBar (frame);      //Button bar object
  cb->Insert (*new TButtonGadget (CM_RUNTHEPIPE,  //New File button gadget
                                  CM_RUNTHEPIPE));

  frame->Insert (*cb, TDecoratedFrame::Top);    //Place the control bar
                                                //on the frame
  SetMainWindow (frame);                        //Create the main window
}                                               //End InitMainWindow


////////////////////////////////////////////////////////////////////////////
// OwlMain - the entry point for this program
////////////////////////////////////////////////////////////////////////////
#pragma argsused                                 //Turn off warnings
int OwlMain (int argc, char* argv[]) {

  TPipes32Application Pipes32;
  return Pipes32.Run ();
}                                                //End OwlMain



